SystemOrganization addCategory: #'Services-Base'!
SystemOrganization addCategory: #'Services-Base-Providers'!
SystemOrganization addCategory: #'Services-Base-Requestors'!
SystemOrganization addCategory: #'Services-Base-GUI'!

!String methodsFor: '*services-base' stamp: 'rr 3/21/2006 12:00'!
service
	^ self serviceOrNil ifNil: [ServiceCategory new id: self asSymbol]! !

!String methodsFor: '*services-base' stamp: 'rr 3/21/2006 12:00'!
serviceOrNil
	^ ServiceRegistry current serviceWithId: self asSymbol! !

Warning subclass: #ServiceCancelled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceCancelled commentStamp: 'rr 4/1/2004 18:24' prior: 0!
Exception raised when a service is cancelled, to inform the user.!

!ServiceCancelled methodsFor: 'as yet unclassified' stamp: 'rr 3/10/2006 17:04'!
defaultAction
	Transcript cr; show: 'service has been cancelled'! !

!ServiceCancelled methodsFor: 'as yet unclassified' stamp: 'rr 3/14/2004 19:14'!
messageText
	^ 'Service has been cancelled'! !

!FillInTheBlankMorph methodsFor: '*services-base' stamp: 'rr 1/9/2006 11:52'!
selection
	"answers what is actually selected in the morph"
	^ textPane selectionInterval! !

!MessageSet methodsFor: '*services-base' stamp: 'rr 8/25/2005 15:42'!
browseReference: ref
	self okToChange ifTrue: [
	self initializeMessageList: (OrderedCollection with: ref).
	self changed: #messageList.
	self messageListIndex: 1.
	] ! !

!MessageSet methodsFor: '*services-base' stamp: 'rr 8/27/2005 13:01'!
selectReference: ref
	self okToChange ifTrue: [self messageListIndex: (self messageList indexOf: ref)]! !

!PreferenceBrowserMorph classSide methodsFor: '*services-base' stamp: 'rr 12/30/2005 18:43'!
updateBrowsers

	(self allInstances select: [:e | e visible]) 
		do: [:each | 
			(each  findDeepSubmorphThat:[:m | m  isKindOf:PluggableListMorph]
				ifAbsent:[^ self]) verifyContents].! !

PreferenceBrowserMorph subclass: #ServiceBrowserMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-GUI'!

!ServiceBrowserMorph commentStamp: 'rr 7/10/2006 15:28' prior: 0!
I subclass the PreferenceBrowserMorph to adapt the interface to services. So far the changes are minimal.!

!ServiceBrowserMorph methodsFor: 'as yet unclassified' stamp: 'rr 7/10/2006 15:26'!
newButtonRow
	^BorderedMorph new
		color: Color transparent; 
		cellInset: 2;
		layoutInset: 2;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		on: #mouseEnter send: #paneTransition: to: self;
		on: #mouseLeave send: #paneTransition: to: self;
		"addMorphBack: self defaultButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveButton;
		addMorphBack: self loadButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveToDiskButton;
		addMorphBack: self loadFromDiskButton;
		addMorphBack: self newSeparator;
		addMorphBack: self newTransparentFiller;
		addMorphBack: self helpButton;"
		yourself.! !

!Browser methodsFor: '*services-base' stamp: 'rr 6/28/2005 15:50'!
browseReference: ref
	self okToChange ifTrue: [
	self selectCategoryForClass: ref actualClass theNonMetaClass.
	self selectClass: ref actualClass theNonMetaClass .
	ref actualClass isMeta ifTrue: [self indicateClassMessages].
	self changed: #classSelectionChanged.
	self selectMessageCategoryNamed: ref category.
	self selectedMessageName: ref methodSymbol.
	]! !

!Browser methodsFor: '*services-base' stamp: 'rr 8/5/2005 10:03'!
methodReference 
	| cls sel |
	cls := self selectedClassOrMetaClass.
	sel := self selectedMessageName.
	cls isNil | sel isNil ifTrue: [^nil].
	^ MethodReference class: cls selector: sel! !

!Browser methodsFor: '*services-base' stamp: 'rr 3/10/2006 16:01'!
optionalButtonRow
	^ServiceGui browserButtonRow: self inlinedIn: super optionalButtonRow! !

!Browser methodsFor: '*services-base' stamp: 'rr 8/3/2005 17:16'!
selectReference: ref
	self browseReference: ref! !

!Association methodsFor: '*services-base-preferences' stamp: 'rr 3/21/2006 11:58'!
serviceUpdate
	self key service perform: self value! !

!SystemWindow class methodsFor: '*services-base' stamp: 'rr 3/10/2006 14:19'!
topWindow
	^ TopWindow! !

!SystemWindow methodsFor: '*services-base' stamp: 'rr 3/24/2004 17:22'!
requestor
	[^model requestor] 
		on: Error 
		do: [Transcript show: 'no requestor for : ', model class name.^ Requestor default] ! !

!SystemWindow methodsFor: '*services-base' stamp: 'rr 3/10/2006 14:15'!
topWindow
	^ TopWindow! !

!StringHolder methodsFor: '*services-base' stamp: 'rr 3/15/2004 09:17'!
codeTextMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableTextMorph)
				and: [dep getTextSelector == #contents]]
		ifNone: []! !

!StringHolder methodsFor: '*services-base' stamp: 'rr 6/9/2005 10:47'!
requestor
	^ (TextRequestor new) model: self; yourself! !

!StringHolder methodsFor: '*services-base' stamp: 'rr 3/15/2004 09:17'!
selectedInterval
	^self codeTextMorph selectionInterval! !

!PasteUpMorph methodsFor: '*services-base' stamp: 'rr 3/14/2006 20:30'!
openWorldMenu
	| menu |
	menu := (TheWorldMenu new adaptToWorld: self) buildWorldMenu.
	menu addTitle: Preferences desktopMenuTitle translated.
	menu openInHand! !

!PasteUpMorph methodsFor: '*services-base' stamp: 'rr 3/10/2006 14:25'!
requestor
	"returns the focused window's requestor"
	^ Requestor default! !

!PasteUpMorph methodsFor: '*services-base' stamp: 'rr 3/10/2006 14:25'!
topRequestor
	"returns the focused window's requestor"
	^ SystemWindow topWindow requestor! !

!PasteUpMorph methodsFor: '*services-base' stamp: 'rr 3/14/2006 20:31'!
worldMenu
	| |
	^ TheWorldMenu new adaptToWorld: self! !

!PreferenceBrowser classSide methodsFor: '*services-base' stamp: 'rr 7/10/2006 15:27'!
openForServices
	"PreferenceBrowser openForServices"
	| browser |
	browser := self new.
	browser initializeForServices.
	(ServiceBrowserMorph withModel: browser)
		openInWorld.
	^browser.	! !

!PreferenceBrowser methodsFor: '*services-base' stamp: 'rr 10/1/2005 15:25'!
initializeForServices
	preferences := ServicePreferences.
	title := 'Services Browser'! !

!CodeHolder methodsFor: '*services-base' stamp: 'rr 3/15/2004 09:21'!
requestor
	^ (BrowserRequestor new) browser: self; yourself! !

!PluggableTextMorph methodsFor: '*services-base' stamp: 'rr 3/21/2004 12:29'!
textMorph
	^ textMorph! !

!Morph methodsFor: '*services-base' stamp: 'rr 6/10/2005 11:30'!
requestor
	^ owner ifNil: [super requestor] ifNotNil: [owner requestor]! !

Preferences subclass: #ServicePreferences
	instanceVariableNames: ''
	classVariableNames: 'ServiceDictionaryOfPreferences'
	poolDictionaries: ''
	category: 'Services-Base-GUI'!

!ServicePreferences commentStamp: 'rr 7/10/2006 15:36' prior: 0!
I store the preferences related to the servicse framework. The preferences are editable via the Services Browser, based on Hernan Tylim's Preference Browser.

The main preference categories for services are: 

-- keyboard shortcuts -- : several text preferences, one per keyboard shortcuts. To edit them,  enter a service identifier (equal to the method name under which it is defined in its ServiceProvider), and accept with alt-s or enter

-- menu contents -- : All the service categories in the image have a text preference under here. To edit it, enter the services identifiers you wish to put in this category, separating them with a single space character. The order is important: it defines the order of the items in menus.

-- settings -- : general boolean preferences.

Then there is a preference category for each provider in the image. Under each, you will find:
A boolean preference for each service in the image. If it is false, the service will not appear in menus. 
The text preference for each service category defined by the service provider. This is the same as the one appearing in the menu contents preference category.!

!ServicePreferences classSide methodsFor: 'accessing' stamp: 'rr 10/11/2005 15:10'!
compileAccessMethodForPreference: aPreference
	"do nothing"! !

!ServicePreferences classSide methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:18'!
dictionaryOfPreferences
	ServiceDictionaryOfPreferences 
		ifNil: [ServiceDictionaryOfPreferences := IdentityDictionary new].
	^ ServiceDictionaryOfPreferences ! !

!ServicePreferences classSide methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:18'!
dictionaryOfPreferences: aDictionary
	ServiceDictionaryOfPreferences := aDictionary! !

!ServicePreferences classSide methodsFor: 'replaying' stamp: 'rr 3/12/2006 15:10'!
replayPreferences: preferences 
	| s v |
	s := SortedCollection new
				sortBlock: [:a :b | a last < b last].
	s addAll: preferences;
		 reSort.
	s
		do: [:e | 
			v := self valueOfPreference: e first ifAbsent: ''.
			self setPreference: e first toValue: (v
					ifEmpty: ['']
					ifNotEmpty: [v , ' '])
					, e second]! !

!ServicePreferences classSide methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:22'!
wipe
	self dictionaryOfPreferences: nil! !

!BlockContext methodsFor: '*services-base' stamp: 'rr 3/21/2006 11:53'!
valueWithRequestor: aRequestor 
	"To do later: make the fillInTheBlank display more informative captions.
	Include the description of the service, and maybe record steps"

	^ self numArgs isZero 
		ifTrue: [self value]
		ifFalse: [self value: aRequestor]! !

Object subclass: #BasicRequestor
	instanceVariableNames: 'caption answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!BasicRequestor commentStamp: 'rr 7/10/2006 14:44' prior: 0!
This class is the root of the Requestor hierarchy.

Requestors are interfaces between services and the system. ServiceActions are given an instance
of a Requestor, and they ask it for the data they need. The requestor is determined by the model of the application. A class used as a model can implement the #requestor message to return the most suited requestor. A requestor knows how to query its model and the user if needed.

Requestor are defined in hierarchies so that the protocol they rely on (methods starting with 'get') can be easily reused.!

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 6/1/2004 21:50'!
caption: aString
	caption := aString! !

!BasicRequestor methodsFor: 'executing' stamp: 'rr 5/31/2004 22:43'!
get: aString
	self caption: aString.
	^ self getSymbol! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'sd 3/16/2008 14:39'!
getString
	| result |
	result := FillInTheBlank  request:caption  initialAnswer:answer contents.
	self newCaption.
	result isEmpty  |result isNil  ifTrue:[ServiceCancelled signal].
	^ result! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:18'!
getStringCollection
	caption := caption, Character cr asString, 'Separate items with space'.
	^ (self getString findTokens: ' ') collect: [:each | each copyWithoutAll: ' ' ]! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:19'!
getSymbol
	^ self getString asSymbol! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:20'!
getSymbolCollection
	^[self getStringCollection collect: [:each | each asSymbol]] 
		on: ServiceCancelled
		do: [#()]! !

!BasicRequestor methodsFor: 'initialize-release' stamp: 'rr 1/9/2006 12:06'!
initialize
	self newCaption! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'sd 3/16/2008 14:40'!
newCaption
	caption := 'Enter text'.
	answer := WriteStream  on:''! !

BasicRequestor subclass: #Requestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Requestors'!

!Requestor commentStamp: 'rr 7/10/2006 15:19' prior: 0!
I am an implementation of BasicRequestor with some requests already implemented.!

!Requestor classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/23/2004 14:32'!
default
	"returns a default requestor"
	^ self new! !

!Requestor methodsFor: 'requests' stamp: 'rr 8/2/2005 14:53'!
getClass
	^Smalltalk at: self getSymbol! !

!Requestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:03'!
getClassCollection
	^ self getSymbolCollection collect: [:className | Smalltalk at: className]! !

!Requestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:07'!
getMethodBody
	| m |
	m := FillInTheBlankMorph new.
	m setQuery: 'Please enter the full body of the method you want to define' 
		initialAnswer:  self class sourceCodeTemplate
		answerExtent: 500@250
		acceptOnCR: false. 
	World addMorph: m centeredNear: World activeHand position.
	^ m getUserResponse.! !

!Requestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:15'!
getSelection
	"Sorry to feedle with fillInTheBlankMorph innards, but I had to"
	| text m |
	text := (MethodReference class: self getClass selector: self getSelector) sourceCode.
	m := FillInTheBlankMorph new.
	m setQuery: 'Highlight a part of the source code, and accept' initialAnswer: text
		answerExtent: 500@250
		acceptOnCR: true. 
	World addMorph: m centeredNear: World activeHand position.
	m getUserResponse.
	^ m selection! !

!Requestor methodsFor: 'services requests' stamp: 'rr 1/9/2006 11:59'!
getSelector
	^ self caption: 'enter selector'; getSymbol! !

Requestor subclass: #TextRequestor
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Requestors'!

!TextRequestor commentStamp: 'rr 7/10/2006 15:20' prior: 0!
A requestor for text areas, able for example to fetch the current selected text.!

TextRequestor subclass: #BrowserRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Requestors'!

!BrowserRequestor commentStamp: 'rr 7/10/2006 15:24' prior: 0!
I am a requestor specialized to fetch information in a Browser.
I can ask a browser its selected class and selected method for example.
If the RB is installed too, I can also fetch ast nodes in the browser's selected
method.

I am the default requestor for CodeHolder and it's subclasses.

To be integrated with services, alternative browsers, such as the OmniBrowser and Whisker should define a specialized requestor subclassing this one. A few core messages would need to be redefined, such as getClass, getMessage ... to be adapted to the browser's data structures. 
Only a few of them have to be overridden, the majority of the requests rely on a few base ones.!

!BrowserRequestor methodsFor: 'initialize-release' stamp: 'rr 8/27/2005 15:52'!
browser: b
	self model: b! !

!BrowserRequestor methodsFor: 'requests' stamp: 'gvc 9/26/2008 15:14'!
getArgumentPermutation
	"Answer the argument permutation map.
	No support for changing argument count."
	
	^(1 to: (self getBrowser selectedMessageName ifNil: [^nil]) numArgs) asArray! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:43'!
getBrowser
	^ self getModel! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getClass
	^ self getBrowser selectedClassOrMetaClass! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 9/11/2004 14:06'!
getInitializingExpressionForTheNewParameter
	^ FillInTheBlank request: 'enter default parameter code'
				 initialAnswer: '42'! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 1/9/2006 11:57'!
getNewSelectorName
	^ FillInTheBlank  request: 'enter the new selector name'
					initialAnswer: self getSelector! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 9/11/2004 16:50'!
getNewVariableName
	^ FillInTheBlank request: 'Enter the new variable name'
				initialAnswer: 'foo'! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/4/2005 14:41'!
getPackage
	self getSelector ifNil: [
			^ PackageInfo named:(
					self getClass ifNil: [self getSystemCategory] 
									ifNotNilDo: [:c | c category copyUpTo:  $-])].
	^ PackageOrganizer default 
			packageOfMethod: 
					(MethodReference class: self getClass
										selector: self getSelector)
			ifNone: [PackageInfo named: (self getClass category copyUpTo:  $-)] ! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageForCategory
	"answers a packageinfo for the current class category"
	^ PackageInfo named: self getClass theNonMetaClass category! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageForCategoryName
	"answers a packageinfo for the current class category"
	^  self getPackageForCategory packageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageName
	^ self getPackage packageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 1/9/2006 19:27'!
getPackageProvider
	| provs classes |
	provs := ServiceProvider registeredProviders.
	classes := self getPackage classes.
	^ classes detect: [:e | provs includes: e] ifNone: [ServiceProvider newProviderFor: self getPackageName]! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:52'!
getSelection
	self getBrowser selectedInterval ifEmpty: [^super getSelection].
	^ self getBrowser selectedInterval! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 1/9/2006 11:58'!
getSelector
	| s |
	s := self getBrowser selectedMessageName.
	^ s ifNil: [super getSelector] ifNotNil: [s]! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 10/11/2005 15:06'!
getSelectorCollection
	self caption: 'enter selector list'.
	^ self getSymbolCollection ! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getSelectorName
	^ self getBrowser selectedMessageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getSystemCategory
	^ self getBrowser selectedSystemCategoryName ! !

!TextRequestor methodsFor: 'request' stamp: 'rr 8/27/2005 15:42'!
getCurrentText
	"returns the unnacepted text in the text morph" 
	^ self getModel codeTextMorph text! !

!TextRequestor methodsFor: 'request' stamp: 'rr 8/27/2005 15:42'!
getModel
	^ model first! !

!TextRequestor methodsFor: 'accessing' stamp: 'rr 8/27/2005 15:42'!
model: aModel
	model := WeakArray with: aModel! !

!Object methodsFor: '*services-base' stamp: 'rr 3/21/2006 11:54'!
requestor
	"returns the focused window's requestor"

	"SystemWindow focusedWindow ifNotNilDo: [:w | ^ w requestor]."

	"triggers an infinite loop"

	^ Requestor default! !

Object subclass: #ServiceAction
	instanceVariableNames: 'condition action requestor label shortLabel description id provider enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceAction commentStamp: 'rr 7/10/2006 14:58' prior: 0!
ServiceAction are executable objects in various contexts.
They can be displayed as buttons or menu items or bounded to keyboard shortcuts.

ServiceActions are defined in methods in an instance of a ServiceProvider class (in the 'services' method category), using the following template:

serviceIdentifierAndMethodName
	^ ServiceAction
		text: 'Menu item text'
		button: 'Button text'
		description: 'Longer text that appears in help balloons'
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		
or, alternatively:

serviceIdentifierAndMethodName
	^ ServiceAction
		text: 'Menu item text'
		button: 'Button text'
		description: 'Longer text that appears in help balloons'
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		condition: [:r | "second block returning true if the service can be used at the time being, false otherwise. Data can still be fetched from the requestor instance"]
		
The method name in which the service is defined becomes its identifier. To build the hierarchy of services and to assign them to shortcuts, you will need to type this names in the relevant fields of the Services Browser.
		
Services are arranged in a hierarchy. and bound to keyboard shortcuts using the ServicesBrowser.
!

!ServiceAction classSide methodsFor: 'instance creation' stamp: 'rr 3/2/2005 17:20'!
id: aSymbol text: aStringOrBlock button: buttonString description: aString action: aBlock
	^ self id: aSymbol 
		text: aStringOrBlock 
		button: buttonString 
		description: aString 
		action: aBlock 
		condition: [:r | true]! !

!ServiceAction classSide methodsFor: 'instance creation' stamp: 'rr 1/9/2006 15:11'!
id: aSymbol text: aStringOrBlock button: buttonString description: aString action: aBlock condition: cBlock
	^ (self new) 
		id: aSymbol;
		text: aStringOrBlock; 
		buttonLabel: buttonString; 
		description: aString; 
		action: aBlock;
		condition: cBlock;
		yourself! !

!ServiceAction classSide methodsFor: 'class initialization' stamp: 'rr 8/19/2005 14:31'!
initialize
	#(
	(inlineServicesInMenu true 'Inline the services the squeak menus') 
	(useOnlyServicesInMenu false 'Use only services and not regular menu items')
	(useServicesInBrowserButtonBar false 'Use a service-based button bar')) 
		do: [:tr |
				Preferences 
						addPreference: tr first
						categories: #(#services)
						default: tr second
						balloonHelp: tr third] 
	! !

!ServiceAction classSide methodsFor: 'instance creation' stamp: 'rr 5/24/2005 17:23'!
text: aStringOrBlock button: buttonString description: aString action: aBlock
	"use when id can be automatically generated"
	^ self id: nil 
		text: aStringOrBlock 
		button: buttonString 
		description: aString 
		action: aBlock 
		condition: [:r | true]! !

!ServiceAction classSide methodsFor: 'instance creation' stamp: 'rr 5/24/2005 17:26'!
text: aStringOrBlock button: buttonString description: aString action: aBlock condition: cBlock
	"use when id can be generated"
	^ self 
		id: nil 
		text: aStringOrBlock 
		button: buttonString 
		description: aString 
		action: aBlock
		condition: cBlock! !

!ServiceAction classSide methodsFor: 'instance creation' stamp: 'rr 5/24/2005 17:24'!
text: textString description: aString action: aBlock
	"use when id can be generated"
	^ self id: nil text: textString button: textString description: aString action: aBlock! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:40'!
action: aBlock
	action := aBlock fixTemps! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 1/12/2006 17:52'!
addPreference: name category: cat selector: sel
	
	ServicePreferences 
		 addPreference: name
		 categories: {cat asSymbol. self providerCategory}
		 default: ''
		 balloonHelp:self description
		 projectLocal:false
		 changeInformee: self id -> sel
		 changeSelector: #serviceUpdate
		 viewRegistry: PreferenceViewRegistry ofTextPreferences! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/8/2006 09:10'!
buttonLabel
	^ shortLabel
		ifNil: [self text]
		ifNotNil: [shortLabel ifEmpty: [self text] ifNotEmpty: [shortLabel]]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 7/5/2005 17:34'!
buttonLabel: anObject
	shortLabel := anObject! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 10/23/2005 14:33'!
categories
	^ ServiceRegistry current categories select: [:e | e services includes: self]! !

!ServiceAction methodsFor: 'executing' stamp: 'rr 11/14/2005 11:11'!
condExecuteWith: aRequestor
	self requestor: aRequestor.
	self executeCondition 
			ifTrue: [self execute] 
			ifFalse: [Beeper beep]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:40'!
condition: aBlock
	condition := aBlock fixTemps! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/9/2006 16:47'!
description

	^ description ifNil: [self text] ifNotNil: [description]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/17/2004 16:49'!
description: anObject
	description := anObject select: [:each | (each = Character cr) not] 
						thenCollect: [:each | each = Character tab ifTrue: [Character space]
															ifFalse: [each]].! !

!ServiceAction methodsFor: 'executing' stamp: 'rr 3/10/2006 14:26'!
execute
	^ action clone valueWithRequestor: World topRequestor! !

!ServiceAction methodsFor: 'executing' stamp: 'rr 3/10/2006 14:26'!
executeCondition
	^ [condition clone valueWithRequestor: World topRequestor]
		on: Error
		do: [false]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/2/2005 17:14'!
id
	^id! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/2/2005 17:15'!
id: aSymbol
	id := aSymbol! !

!ServiceAction methodsFor: 'initialize-release' stamp: 'rr 3/10/2006 10:40'!
initialize
	self
		action: [].
	self
		condition: [true].
	self text: 'no op'.
	self requestor: Requestor new.
	self id: #none.
	enabled := true! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:08'!
insertPreferences
	ServicePreferences
		addPreference: self id
		categories: (Array with: self providerCategory)
		default: true
		balloonHelp: self description
		projectLocal: false
		changeInformee: self id -> #updateEnable
		changeSelector: #serviceUpdate
		viewRegistry: PreferenceViewRegistry ofBooleanPreferences! !

!ServiceAction methodsFor: 'testing' stamp: 'rr 3/2/2005 11:12'!
isCategory
	^ false! !

!ServiceAction methodsFor: 'testing' stamp: 'rr 3/10/2006 10:46'!
isEnabled
	^ enabled! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/12/2006 17:55'!
menuLabel
	| l sh |
	l := self text.
	l size > 50 ifTrue: [l := (l first: 47), '...'].	
	sh := self shortcut.
	sh := (sh isNil or: [sh isEmpty]) ifTrue: [''] ifFalse: [' (', sh, ')'].
	^ l capitalized, sh! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/14/2006 09:45'!
menuLabelNumbered: i
	| l sh str |
	l := self text.
	l size > 50
		ifTrue: [l := (l first: 47)
						, '...'].
	sh := self shortcut.
	sh := (sh isNil
					or: [sh isEmpty])
				ifTrue: ['']
				ifFalse: [' (' , sh , ')'].
	str := i isZero ifTrue: [''] ifFalse: [i asString, '. '].
	^ str, l capitalized , sh! !

!ServiceAction methodsFor: 'executing' stamp: 'rr 1/22/2006 12:55'!
perform: selector orSendTo: otherTarget
	^ self perform: selector! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 1/9/2006 14:08'!
preferences
	^ {ServicePreferences preferenceAt: self shortcutPreference} select: [:e | e notNil]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/8/2006 08:22'!
provider
	^ provider
		ifNil: [nil]
		ifNotNil: [provider new]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/12/2006 17:58'!
provider: p
	provider := p! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:00'!
providerCategory
	^ provider name! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:59'!
requestor
	^requestor! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 3/16/2004 20:59'!
requestor: anObject
	requestor := anObject! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 1/9/2006 16:49'!
shortcut
	^ ServicePreferences valueOfPreference: self shortcutPreference! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 12/30/2005 19:24'!
shortcutPreference 
		^ ('Shortcut for ', self id, ':') asSymbol! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/9/2006 16:47'!
text
	^label isBlock ifTrue: [label fixTemps value: requestor] ifFalse: [label]! !

!ServiceAction methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:52'!
text: aString
	label := aString! !

!ServiceAction methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:10'!
updateEnable
	enabled := ServicePreferences
				valueOfPreference: self id
				ifAbsent: [true]! !

!ServiceAction methodsFor: 'updating' stamp: 'rr 1/12/2006 18:16'!
updateShortcut
	(self systemNavigation allImplementorsOf: #processService:newShortcut:) 
		do: [:ref | | cls |
			cls := ref actualClass.
			cls isMeta ifTrue: [cls soleInstance processService: self newShortcut: self shortcut]].
	ServiceRegistry ifInteractiveDo: [self provider savePreferencesFor: self]! !

ServiceAction subclass: #ServiceCategory
	instanceVariableNames: 'services'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceCategory commentStamp: 'rr 7/10/2006 15:06' prior: 0!
I represent a category of services that can be added to a menu.
I can be displayed as a menu or button bar containing my services.
I am also a subclass of ServiceAction, so I can form a subcategory of another service category.

Like services, I am created in methods of a ServiceProvider, in the 'services' method protocol.
The template to create a service category is the following:

methodNameAndServiceCategoryId
	^ ServiceCategory 
		text: 'Menu text' 
		button: 'Button  text' 
		description: 'Longer descriptive text appearing in help balloons'
	
To put services in a service category, you have to use the Service Browser, located in the word menu, under the 'Preferences and Services' menu item.
In it, you can look up for the name of your category, and enter service identifiers as children
of the category in the associatedd text field, separating them with spaces.!

!ServiceCategory classSide methodsFor: 'instance creation' stamp: 'rr 5/24/2005 17:29'!
text: aStringOrBlock button: buttonString description: aString
	"use when id can be generated"
	^ self id: nil text: aStringOrBlock button: buttonString description: aString action: [] ! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 12/30/2005 19:24'!
childrenPreferences
		^ ('Items in ', self id, ':') asSymbol! !

!ServiceCategory methodsFor: 'accessing' stamp: 'rr 3/10/2006 10:47'!
enabledServices
	^ services
		select: [:e | e isEnabled]! !

!ServiceCategory methodsFor: 'executing' stamp: 'rr 10/14/2005 17:15'!
execute
	"displays the subservices as a submenu"
	ServiceGui openMenuFor: self! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 1/16/2006 07:32'!
externalPreferences
	| p |
	p := ServicePreferences valueOfPreference: self childrenPreferences ifAbsent: [''].
	^ (p findTokens: ' ') collect: [:e | e service]! !

!ServiceCategory methodsFor: 'initialize-release' stamp: 'rr 1/4/2006 16:12'!
initialize

	services := OrderedCollection new.
	super initialize.
	
! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 3/10/2006 09:51'!
insertPreferences
	super insertPreferences.
	ServicePreferences 
		addPreference: self childrenPreferences
		categories: { 
				('-- menu contents --' asSymbol).
				(self providerCategory)}
		default: ''
		balloonHelp: self description
		projectLocal: false
		changeInformee: self id -> #updateChildren
		changeSelector: #serviceUpdate
		viewRegistry: PreferenceViewRegistry ofTextPreferences! !

!ServiceCategory methodsFor: 'testing' stamp: 'rr 3/21/2004 18:25'!
isCategory
	^ true! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 1/19/2006 10:09'!
newChildren
	| s |
	s := ServicePreferences valueOfPreference: self childrenPreferences.
	^ (s findTokens: ' ') collect: [:str | str serviceOrNil]! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 1/19/2006 10:13'!
newChildrenValid
	| s |
	s := ServicePreferences valueOfPreference: self childrenPreferences.
	^ (s findTokens: ' ') allSatisfy: [:str | 
		str serviceOrNil 
			ifNil: [ServiceRegistry ifInteractiveDo: 
						[self inform: str, ' is not a valid service name']. 
					false]
			ifNotNil: [true]]! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 1/12/2006 18:10'!
prefServices
	| s |
	s := ServicePreferences valueOfPreference: self childrenPreferences.
	^ (s findTokens: ' ') collect: [:str | str service]! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 3/12/2006 15:29'!
replaceChildren
	ServiceRegistry ifInteractiveDo: [services
		do: [:s | s provider
				ifNotNilDo: [:p | p class removeSelector: (self id , s id) asSymbol]]].
	services := self newChildren.
	services
		do: [:e | 
			(ServicePreferences preferenceAt: e shortcutPreference)
				ifNotNilDo: [:p | p categoryList: {'-- keyboard shortcuts --'. self id asString}].
			ServiceRegistry
				ifInteractiveDo: [self provider savePreferencesFor: self]]! !

!ServiceCategory methodsFor: 'accessing' stamp: 'rr 4/11/2005 17:22'!
requestor: aRequestor
	super requestor: aRequestor.
	self services do: [:s | s requestor: aRequestor]! !

!ServiceCategory methodsFor: 'accessing' stamp: 'rr 3/25/2004 20:43'!
services
	^services! !

!ServiceCategory methodsFor: 'preferences' stamp: 'rr 3/12/2006 15:13'!
updateChildren

	self newChildrenValid
		ifTrue: [self replaceChildren].
	"PreferenceBrowserMorph updateBrowsers."
	ServiceGui updateBar: self! !

Object subclass: #ServiceGui
	instanceVariableNames: 'menu bar service n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-GUI'!

ServiceGui class
	instanceVariableNames: 'bars'!

!ServiceGui commentStamp: 'rr 7/10/2006 15:29' prior: 0!
I abstract all the UI-related behaviors for the services framework.
In the future I could be changed to be compatible with ToolBuilder!

ServiceGui class
	instanceVariableNames: 'bars'!

!ServiceGui classSide methodsFor: 'registering button bars' stamp: 'rr 8/24/2005 12:01'!
bars
	^ bars! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:00'!
browser: b classCategoryMenu: aMenu 
	^ (self new  for:b  id:#browserClassCategoryMenu)  inlineInMenu:aMenu! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:00'!
browser: b classMenu: aMenu 
	^ (self new  for:b  id:#browserClassMenu)  inlineInMenu:aMenu! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:02'!
browser: b codePaneMenu: aMenu 

	^(self new for: b id: #browserCodePaneMenu) inlineInMenu: aMenu! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:00'!
browser: b messageCategoryMenu: aMenu 
	^ (self new  for:b  id:#browserMethodCategoryMenu)  inlineInMenu:aMenu! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:01'!
browser: b messageListMenu: aMenu 
	^ (self new  for:b  id:#browserMethodMenu)  inlineInMenu:aMenu! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/10/2006 10:13'!
browserButtonRow: aBrowser
	^ (self new for: aBrowser id: #browserButtonBar) buildButtonBar ! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 3/10/2006 16:42'!
browserButtonRow: aBrowser inlinedIn: row 
	| bar |
	self buttonBarServices 
		ifTrue: [bar := (self new for: aBrowser id: #browserButtonBar) buildButtonBar.
			row addMorphBack: bar].
	^ row! !

!ServiceGui classSide methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:38'!
buttonBarServices
	^ ServicePreferences valueOfPreference: #useServicesInBrowserButtonBar ! !

!ServiceGui classSide methodsFor: 'registering button bars' stamp: 'rr 3/10/2006 16:49'!
initialize
	bars := OrderedCollection new.
	(TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu unregisterOpenCommand: 'Services Browser'.
			TheWorldMenu registerOpenCommand: {'Services Browser'. {PreferenceBrowser. #openForServices}}]! !

!ServiceGui classSide methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:37'!
inlineServices
	^ ServicePreferences valueOfPreference: #inlineServicesInMenu ! !

!ServiceGui classSide methodsFor: 'preferences' stamp: 'rr 3/10/2006 16:38'!
onlyServices
	^ ServicePreferences valueOfPreference: #useOnlyServicesInMenu! !

!ServiceGui classSide methodsFor: 'opening menus' stamp: 'rr 7/6/2005 16:09'!
openMenuFor: aServiceCategory
	(self new menuFor: aServiceCategory) invokeModal! !

!ServiceGui classSide methodsFor: 'registering button bars' stamp: 'rr 8/4/2005 15:02'!
registerBar: aBar for: service
	
	self bars removeAllSuchThat: [:a | a value isNil].
	self bars add: (WeakValueAssociation key: service value: aBar).! !

!ServiceGui classSide methodsFor: 'registering button bars' stamp: 'rr 1/10/2006 10:24'!
updateBar: cat
	| newBar |
	self bars 
		select: [:assoc | (assoc key id = cat id) & assoc value notNil] 
		thenDo: [:assoc | 
			cat requestor: assoc key requestor.
			newBar := self new buttonBarFor: cat.
			assoc value removeAllMorphs.
			newBar submorphsDo: [:m | assoc value addMorphBack: m]]! !

!ServiceGui classSide methodsFor: 'registering button bars' stamp: 'rr 1/12/2006 17:41'!
updateBars
	| cat newBar bar oldCat |
	self bars do: [:assoc | 
		(bar := assoc value) ifNotNil: [
			oldCat := assoc key.
			cat := oldCat id service.
			cat requestor: oldCat requestor.
			newBar := self new buttonBarFor: cat.
			bar removeAllMorphs.
			newBar submorphsDo: [:m | bar addMorphBack: m]].
		]! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 1/9/2006 19:08'!
updateMenu: aMenu forModel: aModel selector: selector
	('codePane*' match: selector) ifTrue: [
	(self new for: aModel id: #codeSelectionRefactorings) inlineInMenu: aMenu].
	^ aMenu
	! !

!ServiceGui classSide methodsFor: 'hooks' stamp: 'rr 8/19/2005 14:50'!
worldMenu: aMenu
	^ (self new for: aMenu id: #world) inlineInMenu: aMenu! !

!ServiceGui methodsFor: 'accessing' stamp: 'rr 7/5/2005 18:16'!
bar
	^ bar! !

!ServiceGui methodsFor: 'building' stamp: 'rr 7/8/2005 16:28'!
buildButtonBar
	bar := self buttonBarFor: service.
	self class registerBar: bar for: service.
	^ bar! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/10/2006 10:47'!
buttonBarFor: aServiceCategory 
	self styleBar: self bar.
	aServiceCategory enabledServices
		do: [:each | self bar
				addMorphBack: (self buttonFor: each)].
	^ self bar! !

!ServiceGui methodsFor: 'services' stamp: 'rr 7/6/2005 14:47'!
buttonFor: aService
	^ aService isCategory ifTrue: [self buttonForCategory: aService]
							ifFalse: [self buttonForAction: aService]! !

!ServiceGui methodsFor: 'serviceactions' stamp: 'rr 7/5/2005 18:59'!
buttonForAction: aService 
	"see getstate for availability?"

	| aButton |
	aButton := PluggableButtonMorph 
				on: aService
				getState: nil
				action: #execute.
	self styleButton: aButton.
	aButton
		label: aService buttonLabel;
		setBalloonText: aService description.
	^aButton! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 8/4/2005 15:25'!
buttonForCategory: aService 
	"see getstate for availability?"

	| aButton |
	aButton := PluggableButtonMorph 
				on: [:button | aService requestor: button requestor. 
								self class openMenuFor: aService] fixTemps
				getState: nil
				action: #value:.
	aButton arguments: (Array with: aButton).
	self styleButton: aButton.
	aButton
		label: aService buttonLabel.
	^aButton! !

!ServiceGui methodsFor: 'initialize-release' stamp: 'rr 3/8/2006 10:00'!
for: caller id: id 
	service := id service.
	caller ifNotNil: [service requestor: caller requestor]! !

!ServiceGui methodsFor: 'initialize-release' stamp: 'rr 3/13/2006 23:13'!
initialize
	menu := OrderedCollection new.
	bar := AlignmentMorph newRow.
	n := OrderedCollection with: 0! !

!ServiceGui methodsFor: 'building' stamp: 'rr 3/10/2006 16:39'!
inlineInMenu: aMenu 
	^ self class inlineServices
		ifTrue: [self inlineInMenu: aMenu for: service]
		ifFalse: [aMenu]! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/10/2006 10:47'!
inlineInMenu: aMenu for: aServiceCategory 
	menu addLast: aMenu.
	aServiceCategory enabledServices
		do: [:each | self menuItemFor: each].
	^ self popMenu! !

!ServiceGui methodsFor: 'accessing' stamp: 'rr 7/5/2005 18:50'!
menu
	^ menu last! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/10/2006 15:35'!
menuFor: aServiceCategory 
	| submenu |
	submenu := self subMenuFor: aServiceCategory.
	^ submenu
		addTitle: (aServiceCategory menuLabel)! !

!ServiceGui methodsFor: 'services' stamp: 'rr 1/7/2006 11:43'!
menuItemFor: aService
	[aService isCategory ifTrue: [self menuItemForCategory: aService]
							ifFalse: [self menuItemForAction: aService]] 
		on: Error
		do: [:er | (self confirm: 'menuItemFor: error. debug?') ifTrue: [er signal]]! !

!ServiceGui methodsFor: 'serviceactions' stamp: 'rr 3/13/2006 23:16'!
menuItemForAction: aServiceAction 
	"Returns a menuItem triggering self"
	self menu
		add: (aServiceAction menuLabelNumbered: self n)
		target: aServiceAction
		selector: #execute.
	self menu lastItem isEnabled: aServiceAction executeCondition.
	self menu balloonTextForLastItem: aServiceAction description! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:16'!
menuItemForCategory: aServiceCategory 
	"Returns a menuItem triggering self"
	| submenu |
	submenu := self subMenuFor: aServiceCategory.
	self menu add: (aServiceCategory menuLabelNumbered: self n) subMenu: submenu! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:15'!
n
	^ n last! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:15'!
n: nn
	n removeLast.
	n addLast: nn! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:15'!
popMenu
	| aMenu |
	aMenu := menu removeLast.
	n removeLast.
	self styleMenu: aMenu.
	^ aMenu! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:14'!
pushMenu
	menu addLast: MenuMorph new.
	n addLast: 0! !

!ServiceGui methodsFor: 'styling' stamp: 'rr 7/5/2005 19:07'!
styleBar: aBar
	aBar setNameTo: 'button bar'.
	aBar beSticky;
		 hResizing: #spaceFill;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		clipSubmorphs: true;
		cellInset: 1;
		color: Color white.! !

!ServiceGui methodsFor: 'styling' stamp: 'rr 3/8/2006 14:29'!
styleButton: aButton 
	aButton color: Color transparent;
	onColor: Color transparent offColor: Color transparent;
	
	borderStyle: (BorderStyle width: 1 color: Color gray);
	askBeforeChanging: true;
	clipSubmorphs: true;
	hResizing: #spaceFill;
	vResizing: #spaceFill.
	^ self! !

!ServiceGui methodsFor: 'styling' stamp: 'rr 3/12/2006 11:20'!
styleMenu: aMenu 
	"gradient, etc ..?"
	"aMenu color: Color white;
		
		borderStyle: (BorderStyle width: 1 color: Color gray);
		 clipSubmorphs: true;
		 addDropShadow;
		
		shadowColor: (TranslucentColor
				r: 0.0
				g: 0.0
				b: 0.0
				alpha: 0.666);
		 shadowOffset: 1 @ 1"! !

!ServiceGui methodsFor: 'servicecategory' stamp: 'rr 3/13/2006 23:16'!
subMenuFor: aServiceCategory 
	self pushMenu.
	aServiceCategory enabledServices
		ifEmpty: [self menuItemFor: ServiceAction new].
	aServiceCategory enabledServices
		doWithIndex: [:each :i | self n: i. self menuItemFor: each].
	^ self popMenu! !

Object subclass: #ServiceProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceProvider commentStamp: 'rr 7/10/2006 15:08' prior: 0!
A ServiceProvider references services that are relevant to a given application.

Each application that wishes to use the Services framework must subclass a ServiceProvider.
This class must define a 'services' method category.
Each method implemented in this category will be automatically called by the framework.
Each of these method should be a unary message (taking no argument), and return a fully initialised instance of ServiceAction or ServiceCategory. There are three possible patterns:

1)

serviceIdentifierAndMethodName
	^ ServiceAction
		text: 'Menu item text'
		button: 'Button text'
		description: 'Longer text that appears in help balloons'
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		

2)

serviceIdentifierAndMethodName
	^ ServiceAction
		text: 'Menu item text'
		button: 'Button text'
		description: 'Longer text that appears in help balloons'
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		condition: [:r | "second block returning true if the service can be used at the time being, false otherwise. Data can still be fetched from the requestor instance"]
		
3)

methodNameAndServiceCategoryId
	^ ServiceCategory 
		text: 'Menu text' 
		button: 'Button  text' 
		description: 'Longer descriptive text appearing in help balloons'
	

The organisation of services into categories, and the services bound to keyboard shortcuts are
specified using the Services Browser (see the comment on the class ServicesPreferences for more details). When editing preferences, they are saved as methods on the ServiceProvider, all defined
in the 'saved preferences' method category. Each of thesse methods stores preferences that the provider can replay.
!

ServiceProvider subclass: #BrowserProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Providers'!

!BrowserProvider commentStamp: 'rr 7/10/2006 15:17' prior: 0!
I define the default categories of services dealing with browsing:
- the class category menu (service identifier: browserClassCategoryMenu)
- the class menu (browserClassMenu)
- the method category menu (browserMethodCategoryMenu)
- the browser method menu (browserMethodMenu)
- the browser button bar (browserButtonBar)
- the browser code pane/selection menu (browserCodePaneMenu)!

!BrowserProvider classSide methodsFor: 'initialize-release' stamp: 'rr 1/10/2006 12:53'!
initialize
	ServiceRegistry current buildProvider: self new! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 10/23/2005 14:42'!
browser
	^ ServiceCategory  text: 'Browser' 
					button: 'browser' 
					description: 'The browser menus'! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 18:59'!
browserButtonBar
	^ ServiceCategory 
		 text:'button bar'
		 button:'button'
		 description:'the browser button bar'! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:00'!
browserClassCategoryMenu
	^ ServiceCategory 
		 text:'Class Category'
		 button:'class cat'
		 description:'The browser class category menu'! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:00'!
browserClassMenu
	^ ServiceCategory 
		 text:'Class'
		 button:'class'
		 description:'The browser class menu'! !

!BrowserProvider methodsFor: 'saved preferences' stamp: ''!
browserClassMenushortcut
	^ #(#'Shortcut for browserClassMenu:' '' 1000 )! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:01'!
browserCodePaneMenu
	^ ServiceCategory text: 'Code Pane' 
						button: 'pane' 
						description: 'The browser code pane menu'! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:00'!
browserMethodCategoryMenu
	^ ServiceCategory 
		 text:'Method Category'
		 button:'method cat'
		 description:'The browser method menu'! !

!BrowserProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:01'!
browserMethodMenu
	^ ServiceCategory 
		 text:'Method'
		 button:'method'
		 description:'The browser method menu'! !

!BrowserProvider methodsFor: 'saved preferences' stamp: ''!
browserMethodMenushortcut
	^ #(#'Shortcut for browserMethodMenu:' '' 1000 )! !

!ServiceProvider classSide methodsFor: 'provider creation' stamp: 'rr 1/10/2006 10:41'!
newProviderFor: packageName
	| cls clsName |
	clsName := ((packageName copyWithout: $-) , 'ServiceProvider') asSymbol.
	cls := self subclass: clsName
		instanceVariableNames: '' 
		classVariableNames: '' 
		poolDictionaries: ''
		category: packageName.
	cls class compile: 'initialize 
	ServiceRegistry buildProvider: self new' classified: 'initialization'.
	^ cls! !

!ServiceProvider classSide methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:20'!
registeredProviders
	^ self allSubclasses collect: [:each | each new]! !

!ServiceProvider methodsFor: 'accessing' stamp: 'rr 8/2/2005 17:33'!
performAndSetId: aSymbol 
	| service |
	service := self perform: aSymbol.
	service id: aSymbol.
	^service! !

!ServiceProvider methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:23'!
registeredServices
	
	^ self services collect: [:each | self performAndSetId: each]! !

!ServiceProvider methodsFor: 'persistence' stamp: 'rr 1/10/2006 09:22'!
replayPreferences
	ServicePreferences replayPreferences: self savedPreferences! !

!ServiceProvider methodsFor: 'persistence' stamp: 'rr 3/10/2006 15:04'!
savePreferencesFor: aService 
	| strm |
	"pref := ServicePreferences preferenceAt: aService shortcutPreference.
	strm := WriteStream with: ''.
	strm nextPutAll: aService id;
		 nextPutAll: 'shortcut';
		 cr;
		 tab;
		 nextPutAll: '^ ';
		 nextPutAll: {pref name. pref preferenceValue. 1000} storeString.
	self class compileSilently: strm contents classified: 'saved preferences'."
	aService isCategory
		ifTrue: [aService externalPreferences
				doWithIndex: [:e :i | 
					strm := WriteStream with: aService id asString.
					strm nextPutAll: e id asString;
						 cr;
						 tab;
						 nextPutAll: '^ ';
						 nextPutAll: {aService childrenPreferences. e id. i} storeString.
					e provider class compileSilently: strm contents classified: 'saved preferences']]! !

!ServiceProvider methodsFor: 'persistence' stamp: 'rr 1/11/2006 16:11'!
savedPreferences
	 ^ (self class organization listAtCategoryNamed: #'saved preferences')
			collect: [:e | self perform: e]! !

!ServiceProvider methodsFor: 'accessing' stamp: 'rr 1/9/2006 14:23'!
services
	^ self class organization listAtCategoryNamed: #services! !

ServiceProvider subclass: #WorldMenuProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base-Providers'!

!WorldMenuProvider commentStamp: 'rr 7/10/2006 15:19' prior: 0!
I define services and categories:
- The world menu category (identifier:  world), where services and categories can be put to be displayed in the world menu.
- The preferencesMenu category, where services about services and preferences can be put
- th open menu!

!WorldMenuProvider classSide methodsFor: 'initialize-release' stamp: 'rr 1/10/2006 12:53'!
initialize
	ServiceRegistry current buildProvider: self new! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
browserMethodMenucreateNewService
	^ #(#'Items in browserMethodMenu:' #createNewService 1 )! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 3/11/2006 19:11'!
closeTopWindow
	^ ServiceAction
		text: 'Close top window'
		button: 'close window'
		description: 'Closes the focused window'
		action: [:r | SystemWindow topWindow delete]! !

!WorldMenuProvider methodsFor: 'service registering' stamp: 'rr 3/25/2005 14:23'!
convertOpenCommand: array 
	| description |
	description := array size > 2 
				ifTrue: [array third]
				ifFalse: ['none available'].
	^ServiceAction 
		id: array first asSymbol
		text: array first
		button: array first
		description: description
		action: [array second first perform: array second second]! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 1/10/2006 10:41'!
createNewService
	^ ServiceAction 
		text: 'Create new service' 
		button: 'new service' 
		description: 'Define a new service provided by this package' 
		action: [:r | | s p |
			s := r caption: 'enter service identifier'; getSymbol.
			p := r getPackageProvider.
			p compile: s, ' 
	^ ServiceAction 
		"Open the service browser to set the menu position and the keyboard shortcut"
		text: ''fill menu label''
		button: ''short button text''
		description: ''longer text for balloon help''
		action: [:r | "action block"]
		condition: [:r | "optional condition block"]' classified: 'services'.
			r getBrowser browseReference: (MethodReference class: p selector: s)]! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 7/10/2006 15:43'!
helpOnServices
	^ ServiceAction
		text: 'Help on Services'
		button: 'services help'
		description: 'Introductory text about services'
		action: [StringHolder new contents: self servicesHelpText; openLabel: 'Introduction to Services'].! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 3/11/2006 19:10'!
nextWindow
	^ ServiceAction text: 'Switch to next window' button: 'next window' description: 'Switches to the next window' action: [:r | SystemWindow sendTopWindowToBack]! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 10/20/2005 22:50'!
openMenu
	^ ServiceCategory text: 'Open' button: 'open' description: 'The open menu'! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:15'!
preferencesBrowser
	^ ServiceAction text: 'Preference Browser' button: 'pref. browser' description: 'Open the preference browser to edit various Squeak settings' action: [PreferenceBrowser open].! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:14'!
preferencesMenu
	^ ServiceCategory text: 'Preferences & Services' button: 'preferences' description: 'Menu related to editing preferences'! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
preferencesMenuhelpOnServices
	^ #(#'Items in preferencesMenu:' #helpOnServices 3 )! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
preferencesMenupreferencesBrowser
	^ #(#'Items in preferencesMenu:' #preferencesBrowser 1 )! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
preferencesMenurebuildRegistry
	^ #(#'Items in preferencesMenu:' #rebuildRegistry 4 )! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
preferencesMenuservicesBrowser
	^ #(#'Items in preferencesMenu:' #servicesBrowser 2 )! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
preferencesMenushortcut
	^ #(#'Shortcut for preferencesMenu:' '' 1000 )! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:18'!
rebuildRegistry
	^ ServiceAction text: 'Rebuild service registry' button: 'rebuild registry' description: 'Rebuilds the service registry to scan for newly defined services' action: [ServiceRegistry rebuild].! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 1/9/2006 19:16'!
servicesBrowser
	^ ServiceAction text: 'Services Browser' button: 'services' description: 'Open a preference browser to edit several Squeak menus' action: [PreferenceBrowser openForServices].! !

!WorldMenuProvider methodsFor: 'accessing' stamp: 'rr 7/10/2006 16:00'!
servicesHelpText
	^ '
	This is an overview of the main concepts of the services framework. More details are available in class comments. The aim is to help you defining services step by step. The three main classes are: 

-ServiceAction
-ServiceCategory
-ServiceProvider

Alongside them, a tool to use is the Services Browser. It can be found in the world menu, under the ''Preferences & Services'' menu heading (in which you found this text).
	
	ServiceAction are executable objects in various contexts.
They can be displayed as buttons or menu items or bounded to keyboard shortcuts.

	ServiceCategory are categories of services. They are also services, so a ServiceCategory can be included in another, forming a tree of Services. ServiceCategories can be displayed with menus, or button bars.
	
	A ServiceProvider references services that are relevant to a given application.
Each application that wishes to use the Services framework must subclass a ServiceProvider.
This class must define a ''services'' method category.
Each method implemented in this category will be automatically called by the framework.
Each of these method should be a unary message (taking no argument), and return a fully initialised instance of ServiceAction or ServiceCategory. There are three possible patterns:

1)
serviceIdentifierAndMethodName
	^ ServiceAction
		text: ''Menu item text''
		button:''Button text''
		description: ''Longer text that appears in help balloons''
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		
2)
serviceIdentifierAndMethodName
	^ ServiceAction
		text: ''Menu item text''
		button: ''Button text''
		description: ''Longer text that appears in help balloons''
		action: [:r | "Code block fetching data from the requestor instance, r, that is passed to the block"]
		condition: [:r | "second block returning true if the service can be used at the time being, false otherwise. Data can still be fetched from the requestor instance"]
		
3)
methodNameAndServiceCategoryId
	^ ServiceCategory 
		text: ''Menu text''
		button: ''Button  text'' 
		description: ''Longer descriptive text appearing in help balloons''

The block given to the ServiceActions can take an instance of the Requestor class as parameter. You can fetch data from these. The generic format is to call methods starting with ''get'' on the requestor, like getClass, getMessageName for services related to the browser.	

The organisation of services into categories, and the services bound to keyboard shortcuts are
specified using the Services Browser, based on the Preference Browser by Hernan Tylim. When editing preferences, they are saved as methods on the ServiceProvider, all defined in the ''saved preferences'' method category. 

When opening the Services Browser you see a list of preference categories on the left, and the preferences inside this category on the right. The main preference categories for services are: 

-- keyboard shortcuts -- : several text preferences, one per keyboard shortcuts. To edit them,  enter a service identifier (equal to the method name under which it is defined in its ServiceProvider), and accept with alt-s or enter

-- menu contents -- : All the service categories in the image have a text preference under here. To edit it, enter the services identifiers you wish to put in this category, separating them with a single space character. The order is important: it defines the order of the items in menus.

-- settings -- : general boolean preferences.

Then there is a preference category for each provider in the image. Under each, you will find:
A boolean preference for each service in the image. If it is false, the service will not appear in menus. 
The text preference for each service category defined by the service provider. This is the same as the one appearing in the menu contents preference category.

Some identifiers of categories already appearing in the UI are:
- world : the world menu
- preferencesMenu
- browserClasssCategoryMenu
- browserClassMenu
- browserMethodCategoryMenu
- browserMethodMenu
- browserCodePaneMenu
- browserButtonBar

After editing these preferences to match the services and categories you defined for your application, you should be done.

	Romain Robbes'! !

!WorldMenuProvider methodsFor: 'services' stamp: 'rr 10/20/2005 22:49'!
world
	^ ServiceCategory text: 'World' button: 'world' description: 'The world menu'! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
worldpreferencesMenu
	^ #(#'Items in world:' #preferencesMenu 1 )! !

!WorldMenuProvider methodsFor: 'saved preferences' stamp: ''!
worldshortcut
	^ #(#'Shortcut for world:' '' 1000 )! !

Object subclass: #ServiceRegistry
	instanceVariableNames: 'services interactive'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Services-Base'!

!ServiceRegistry commentStamp: 'rr 7/10/2006 15:10' prior: 0!
The ServiceRegistry is the repository in which services are stored. They are stored in
a dictionary, and keyed by their identifier (which is the name of the method they were defined in).

The registry handles the intialization, building and referencing processes as well.!

!ServiceRegistry classSide methodsFor: 'as yet unclassified' stamp: 'rr 1/10/2006 13:00'!
current
	^ Current ifNil: [Current := self new]! !

!ServiceRegistry classSide methodsFor: 'as yet unclassified' stamp: 'rr 1/12/2006 12:48'!
ifInteractiveDo: aBlock
	self current isInteractive ifTrue: [aBlock value]! !

!ServiceRegistry classSide methodsFor: 'as yet unclassified' stamp: 'rr 1/10/2006 13:01'!
initialize

	self rebuild.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #method 
		using: #methodChanged:
		! !

!ServiceRegistry classSide methodsFor: 'as yet unclassified' stamp: 'rr 1/12/2006 12:35'!
methodChanged: event
	| cls | 
	self ifInteractiveDo: [
	cls := event itemClass. 
	((event changeKind = #removed) not & (cls inheritsFrom: ServiceProvider) and: [cls new services includes: event itemSelector])
		ifTrue: [[self current addService: (cls new performAndSetId: event itemSelector)
					provider: cls]
			on: Error do: [self inform: 'Service format seems to be incorrect']]]! !

!ServiceRegistry classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/12/2006 15:19'!
rebuild
	| old |
	old := Current.
	[Current := self new.
	Current build]
		on: Error
		do: [:err | (self confirm: 'An error occured during build. 
								Debug it?')
				ifTrue: [err signal].
				Current := old]! !

!ServiceRegistry methodsFor: 'building' stamp: 'rr 1/11/2006 16:37'!
addService: aService provider: p
	services  at:aService id  put:aService.
	aService provider: p.
	aService insertPreferences
! !

!ServiceRegistry methodsFor: 'building' stamp: 'rr 1/10/2006 12:10'!
beNotInteractiveDuring: aBlock
	interactive := false.
	aBlock value.
	interactive := true! !

!ServiceRegistry methodsFor: 'building' stamp: 'rr 5/17/2006 16:02'!
build
	"ServicePreferences wipe."
	| pr |
	self
		beNotInteractiveDuring: [ServiceProvider registeredProviders
				do: [:p | p registeredServices
						do: [:each | self addService: each provider: p class]].
			pr := ServiceProvider registeredProviders
						gather: [:p | p savedPreferences].
			ServicePreferences replayPreferences: pr.
			].
	ServiceGui updateBars.
	ServiceShortcuts setPreferences! !

!ServiceRegistry methodsFor: 'building' stamp: 'rr 1/11/2006 16:38'!
buildProvider: p
	self beNotInteractiveDuring: [
		p registeredServices do: [:each | self addService: each provider: p class].
		p replayPreferences]
	! !

!ServiceRegistry methodsFor: 'accessing' stamp: 'rr 3/2/2005 11:19'!
categories
	^ self serviceCollection select: [:s | s isCategory]! !

!ServiceRegistry methodsFor: 'initialize-release' stamp: 'rr 1/10/2006 12:18'!
initialize
	services := Dictionary new.
	interactive := true! !

!ServiceRegistry methodsFor: 'accessing' stamp: 'rr 10/20/2005 18:45'!
isInteractive
	^ interactive! !

!ServiceRegistry methodsFor: 'accessing' stamp: 'rr 3/2/2005 11:18'!
serviceCollection
	^ services asArray! !

!ServiceRegistry methodsFor: 'accessing' stamp: 'rr 1/16/2006 07:36'!
serviceWithId: aSymbol
	^ services at: aSymbol 
				ifAbsent: [nil]! !

!ServiceRegistry methodsFor: 'accessing' stamp: 'rr 3/2/2005 11:26'!
services
	^ self serviceCollection reject: [:s | s isCategory]! !

Object subclass: #ServiceShortcuts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Services-Base'!

ServiceShortcuts class
	instanceVariableNames: 'map'!

!ServiceShortcuts commentStamp: 'rr 7/10/2006 15:14' prior: 0!
A data structures implementing a simple form of keyboard shortucts is defined on the class side.

Available keyboard shortcuts are: 

command-0 to command-9 (command is also called alt on some systems).
control-0 to control-0
command-control-0 to command-control-9 (command is also alt)
control-command-left arrow
control-command-up arrow
control-command-right arrow
control-command-down arrow

Using the Services Browser (see class ServicePreferences), these shortcuts can be bound to service identifiers.!

ServiceShortcuts class
	instanceVariableNames: 'map'!

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2006 19:05'!
arrowShortcut: str event: event 
	| key s |
	key := event keyCharacter caseOf: {
				[Character arrowDown] -> ['down'].
				[Character arrowUp] -> ['up'].
				[Character arrowLeft] -> ['left'].
				[Character arrowRight] -> ['right']}.
	s := self map
				at: str , key
				ifAbsent: [^ self].
	s serviceOrNil
		ifNotNilDo: [:sv | sv execute.
	event wasHandled: true]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'nice 2/27/2008 21:49'!
changeShortcut: shortcut to: aString
	aString isBlock ifTrue: [^self map at: shortcut put: aString].
	(aString beginsWith: '[') ifTrue: [^self map at: shortcut put: aString].
	aString isEmpty ifTrue: [self map removeKey: shortcut ifAbsent: []]
				ifFalse: [self map at: shortcut put: aString]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/10/2006 14:20'!
handleKeystroke: event 
	[event isKeystroke
		ifTrue: [self process: event]]
		on: Error
		do: [:e | (self confirm: 'shortcut error. debug?') ifTrue: [e signal]]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2006 14:03'!
insertPrefShortcut: short
					ServicePreferences
						addPreference: short
						categories: #('-- keyboard shortcuts --' )
						default: ''
						balloonHelp: 'enter a service id to bind it to this shortcut'
						projectLocal: false
						changeInformee: [self
								changeShortcut: short
								to: (ServicePreferences valueOfPreference: short)] fixTemps
						changeSelector: #value
						viewRegistry: PreferenceViewRegistry ofTextPreferences! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/9/2006 16:31'!
map
	^ map ifNil: [map := Dictionary new]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2006 19:04'!
process: event 
	event keyCharacter isDigit
		ifTrue: [event commandKeyPressed & event controlKeyPressed
				ifTrue: [^ self shortcut: 'ctrl-cmd-' event: event].
			event commandKeyPressed
				ifTrue: [^ self shortcut: 'cmd-' event: event].
			event controlKeyPressed
				ifTrue: [^ self shortcut: 'ctrl-' event: event]].
	({Character arrowUp. Character arrowDown. Character arrowLeft. Character arrowRight} includes: event keyCharacter)
		ifTrue: [event commandKeyPressed & event controlKeyPressed
				ifTrue: [^ self arrowShortcut: 'ctrl-cmd-' event: event].
			]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'rr 3/11/2006 19:05'!
setPreferences
	| mm |
	mm := self map copy.
	(0 to: 9)
		do: [:i | #('ctrl-' 'cmd-' 'ctrl-cmd-' )
				do: [:str | 
					| short | 
					short := (str , i asString) asSymbol.
					self insertPrefShortcut: short]].
	#(#up #down #left #right )
		do: [:s | 
			self insertPrefShortcut: ('ctrl-cmd-' , s) asSymbol.].
	mm
		keysAndValuesDo: [:k :v | ServicePreferences setPreference: k toValue: v].
	((Array new: 3) at: 1 put: ((Array new: 3) at: 1 put: #inlineServicesInMenu;
			 at: 2 put: true;
			 at: 3 put: 'Inline the services the squeak menus';
			 yourself);
		 at: 2 put: ((Array new: 3) at: 1 put: #useOnlyServicesInMenu;
			 at: 2 put: false;
			 at: 3 put: 'Use only services and not regular menu items';
			 yourself);
		 at: 3 put: ((Array new: 3) at: 1 put: #useServicesInBrowserButtonBar;
			 at: 2 put: true;
			 at: 3 put: 'Use a service-based button bar';
			 yourself);
		 yourself)
		do: [:tr | ServicePreferences
				addPreference: tr first
				categories: #('-- settings --' )
				default: tr second
				balloonHelp: tr third]! !

!ServiceShortcuts classSide methodsFor: 'as yet unclassified' stamp: 'nice 2/27/2008 21:50'!
shortcut: str event: event 
	| s |
	Transcript cr.
	s := self map
				at: str , event keyCharacter asString
				ifAbsent: [^ self].
	(s beginsWith: '[') ifTrue: [^ (Compiler evaluateUnloggedForSelf:  s) value].
	s serviceOrNil
		ifNotNilDo: [:sv | sv execute.
	event wasHandled: true]! !

!Collection methodsFor: '*services-base' stamp: 'rr 3/21/2006 11:59'!
chooseOne: caption 
	"pops up a menu asking for one of the elements in the collection.
	If none is chosen, raises a ServiceCancelled notification"

	| m |
	m := MenuMorph entitled: caption.
	self do: 
			[:ea | 
			m 
				add: ea
				target: [:n | ^ n]
				selector: #value:
				argument: ea].
	m invokeModal.
	ServiceCancelled signal! !
BrowserProvider initialize!
ServiceAction initialize!
ServiceGui initialize!
ServiceRegistry initialize!
WorldMenuProvider initialize!
